#include "all.h"

void qsort(vector<char> & array,int begin,int end)
{
	if(end <= begin)
		return;

	int q = partition(array,begin,end);
	qsort(array,begin,q - 1);
	qsort(array,q + 1,end);
}

int partition(vector<char> & array,int begin,int end)
{
	char x = array[begin];
	int i = begin - 1;
	int j = end + 1;

	while(true)
	{
		do
		i++;
		while(array[i] <= x && i < j);

		do
		j--;
		while(array[j] > x && i < j);

		if(i < j)
			swap(array[i],array[j]);
		else
		{
			swap(array[begin],array[i - 1]);
			return i - 1;
		}
	}
}